' Demonstration der BMP-Laderoutinen: Bilderanzeigeprogramm

' (c) 1999 by Andreas Meile, CH-8242 Hofen SH
' e-Mail: andreas@hofen.ch  WWW: http://www.hofen.ch/~andreas/

' $INCLUDE: 'bmp_lib.bi'

FILES "*.bmp"
INPUT "Dateiname (ohne .BMP!)"; d$
HoleBildInfo d$, b&, h&, t%, g%
PRINT "Dieses Bild ist"; b&; "x"; h&; "Pixel gross und"; t%; "Bit(s) tief."
PRINT "Grsse des GET/PUT-Feldes"; g%; "Elemente"
PRINT "Weiter mit Taste"; INPUT$(1)
DIM h#(g% - 1), pa&(255)
pf% = 0
pp% = 0
LadeBild d$, h#(), pf%

SELECT CASE t%
CASE 1
  IF h& <= 200& THEN
    SCREEN 2
    LadePalette d$, pa&(), pp%, PalCGA%
  ELSEIF b& <= 640& AND h& <= 480& THEN
    SCREEN 11
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 4
  IF h& <= 200& THEN
    IF w& <= 320& THEN
      SCREEN 7
    ELSE
      SCREEN 8
    END IF
    LadePalette d$, pa&(), pp%, PalCGA%
  ELSEIF h& <= 350& THEN
    SCREEN 9
    LadePalette d$, pa&(), pp%, PalEGA%
  ELSEIF b& <= 640& AND h& <= 480& THEN
    SCREEN 12
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 8
  IF b& <= 320& AND h& <= 200& THEN
    SCREEN 13
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 24
  PRINT "Echtfarb (TrueColor) nicht untersttzt!"
  END
CASE ELSE
  PRINT "Nicht untersttzte Tiefe:"; t%
  END
END SELECT

' Grsse messen
bx% = 0
WHILE POINT(bx%, 0) <> -1
  bx% = bx% + 1
WEND
by% = 0
WHILE POINT(0, by%) <> -1
  by% = by% + 1
WEND
brx% = bx% \ 52
bry% = by% \ 39
anzx% = (bx% - 1) \ brx%
anzy% = (by% - 1) \ bry%
' Vieregglimuster erzeugen
FOR y% = 0 TO anzy%
  FOR x% = 0 TO anzx%
    SELECT CASE t%
    CASE 1
      f% = (x% XOR y%) AND 1
    CASE 4
      f% = (x% AND 3) + 4 * (y% AND 3)
    CASE 8
      f% = (x% AND 15) + 16 * (y% AND 15)
    END SELECT
    LINE (brx% * x%, bry% * y%)-STEP(brx% - 1, bry% - 1), f%, BF
  NEXT x%
NEXT y%

PUT ((bx% - CINT(b&)) \ 2, (by% - CINT(h&)) \ 2), h#, PSET
PALETTE USING pa&

d$ = INPUT$(1)
SCREEN 0
WIDTH 80, 25

